package cz.muni.pa165.account;

import cz.muni.pa165.account.data.repository.AccountRepository;
import cz.muni.pa165.account.service.AccountService;
import cz.muni.pa165.core.exception.ResourceNotFoundException;
import java.util.Optional;
import org.mockito.Mockito;
import org.springframework.boot.test.context.TestConfiguration;
import org.springframework.context.annotation.Bean;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;

@TestConfiguration
public class AccountTestConfiguration {

    @Bean
    public AccountService accountService() {
        AccountRepository repository = mockRepositoryMethods();
        return new AccountService(repository);
    }

    private AccountRepository mockRepositoryMethods() {
        AccountRepository repository = Mockito.mock(AccountRepository.class);

        Mockito
            .doThrow(ResourceNotFoundException.class)
            .when(repository)
            .findById(Mockito.anyLong());
        Mockito
            .doReturn(Optional.of(MockedEntities.JOHN_WICK))
            .when(repository)
            .findById(MockedEntities.JOHN_WICK.getId());
        Mockito
            .doReturn(new PageImpl<>(MockedEntities.ACCOUNTS))
            .when(repository)
            .findAll(Mockito.any(Pageable.class));
        Mockito
            .doReturn(MockedEntities.JOHN_WICK)
            .when(repository)
            .save(MockedEntities.JOHN_WICK);

        return repository;
    }
}
