package cz.muni.pa165.genre;

import cz.muni.pa165.core.exception.ResourceNotFoundException;
import cz.muni.pa165.genre.data.repository.GenreRepository;
import java.util.Optional;
import org.junit.jupiter.api.BeforeEach;
import org.mockito.Mockito;
import org.mockito.MockitoAnnotations;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;

public abstract class GenreTestBase {

    @MockBean
    protected GenreRepository repository;

    @BeforeEach
    public void setup() {
        MockitoAnnotations.openMocks(this);
        mockRepositoryMethods();
    }

    private void mockRepositoryMethods() {
        Mockito
            .doThrow(ResourceNotFoundException.class)
            .when(repository)
            .findById(Mockito.anyLong());
        Mockito
            .doReturn(Optional.of(MockedEntities.ACTION))
            .when(repository)
            .findById(MockedEntities.ACTION.getId());
        Mockito
            .doReturn(Optional.of(MockedEntities.ACTION))
            .when(repository)
            .findById(1L);

        Mockito
            .doReturn(new PageImpl<>(MockedEntities.GENRE_LIST))
            .when(repository)
            .findAll(Mockito.any(Pageable.class));

        Mockito
            .doReturn(MockedEntities.ACTION)
            .when(repository)
            .save(MockedEntities.ACTION);
    }
}
