package cz.muni.pa165.movie;

import cz.muni.pa165.movie.data.model.Movie;
import cz.muni.pa165.movie.data.model.Person;
import java.util.List;
import java.util.Set;

public class MockedEntities {

    public static final Person JOHNNY_DEPP;
    public static final Person ORLANDO_BLOOM;
    public static final Person KEIRA_KNIGHTLEY;
    public static final Person GORE_VERBINSKI;

    public static final Movie PIRATES_OF_THE_CARIBBEAN;
    public static final Movie RANGO;

    public static final List<Movie> MOVIES;

    // Initialize persons
    static {
        JOHNNY_DEPP = new Person();
        JOHNNY_DEPP.setName("Johnny");
        JOHNNY_DEPP.setSurname("Depp");

        ORLANDO_BLOOM = new Person();
        ORLANDO_BLOOM.setName("Orlando");
        ORLANDO_BLOOM.setSurname("Bloom");

        KEIRA_KNIGHTLEY = new Person();
        KEIRA_KNIGHTLEY.setName("Keira");
        KEIRA_KNIGHTLEY.setSurname("Knightley");

        GORE_VERBINSKI = new Person();
        GORE_VERBINSKI.setName("Gore");
        GORE_VERBINSKI.setSurname("Verbinski");
    }

    // Initialize PIRATES_OF_THE_CARIBBEAN
    static {
        final Set<Person> actors = Set.of(
            JOHNNY_DEPP,
            ORLANDO_BLOOM,
            KEIRA_KNIGHTLEY
        );
        final Person director = GORE_VERBINSKI;
        final Set<Long> genres = Set.of(1L, 5L);
        final Set<String> images = Set.of(
            "https://example.com/image1.jpg",
            "https://example.com/image2.jpg"
        );

        PIRATES_OF_THE_CARIBBEAN = new Movie();
        PIRATES_OF_THE_CARIBBEAN.setTitle("Pirates of the Caribbean");
        PIRATES_OF_THE_CARIBBEAN.setDescription(
            "A pirate captain and his crew are in search of a legendary treasure."
        );
        PIRATES_OF_THE_CARIBBEAN.setActors(actors);
        PIRATES_OF_THE_CARIBBEAN.setDirector(GORE_VERBINSKI);
        PIRATES_OF_THE_CARIBBEAN.setGenreIds(genres);
        PIRATES_OF_THE_CARIBBEAN.setImages(images);

        director.getMoviesDirected().add(PIRATES_OF_THE_CARIBBEAN);
        actors.forEach(actor ->
            actor.getMoviesActedIn().add(PIRATES_OF_THE_CARIBBEAN)
        );
    }

    // Initialize RANGO
    static {
        final Set<Person> actors = Set.of(JOHNNY_DEPP);
        final Person director = GORE_VERBINSKI;
        final Set<Long> genres = Set.of(3L, 5L);
        final Set<String> images = Set.of("https://example.com/image3.jpg");

        RANGO = new Movie();
        RANGO.setTitle("Rango");
        RANGO.setDescription(
            "A chameleon who struggles to find his place in a world of animals."
        );
        RANGO.setActors(actors);
        RANGO.setDirector(director);
        RANGO.setGenreIds(genres);
        RANGO.setImages(images);

        director.getMoviesDirected().add(RANGO);
        actors.forEach(actor -> actor.getMoviesActedIn().add(RANGO));
    }

    // Initialize MOVIES
    static {
        MOVIES = List.of(PIRATES_OF_THE_CARIBBEAN, RANGO);
    }
}
